문제
수빈이는 동생과 숨바꼭질을 하고 있다. 수빈이는 현재 점 N(0 ≤ N ≤ 100,000)에 있고, 동생은 점 K(0 ≤ K ≤ 100,000)에 있다. 수빈이는 걷거나 순간이동을 할 수 있다. 만약, 수빈이의 위치가 X일 때 걷는다면 1초 후에 X-1 또는 X+1로 이동하게 된다. 순간이동을 하는 경우에는 1초 후에 2*X의 위치로 이동하게 된다.
수빈이와 동생의 위치가 주어졌을 때, 수빈이가 동생을 찾을 수 있는 가장 빠른 시간이 몇 초 후인지 구하는 프로그램을 작성하시오.
입력
첫 번째 줄에 수빈이가 있는 위치 N과 동생이 있는 위치 K가 주어진다. N과 K는 정수이다.
출력
수빈이가 동생을 찾는 가장 빠른 시간을 출력한다.
예제 입력 1
5 17
예제 출력 1
4
풀이 1. (틀린 코드)
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
public class Main {
static BufferedReader br = null;
static StringTokenizer st = null;
static int n, k, ans;
static boolean[] check = null;
public static void dfs(int now, int deptNow, int destination) {
if(deptNow > ans) { // 최소 경로 구하는 것이므로 경로가 더 커지면 그냥 바로 나가면 된다.
return;
}
if(now == destination) {
ans = deptNow;
return;
}
if(0 <= now+1 && now+1 <= 100000 && !check[now+1]) {
check[now+1] = true;
dfs(now + 1, deptNow + 1, destination);
}
if(0 <= now-1 && now-1 <= 100000 && !check[now-1]) {
check[now-1] = true;
dfs(now - 1, deptNow + 1, destination);
}
if(0 <= now*2 && now*2 <= 100000 && !check[now*2]) {
check[now*2] = true;
dfs(now * 2, deptNow + 1, destination);
}
}
public static void main(String[] args) throws IOException {
br = new BufferedReader(new InputStreamReader(System.in));
st = new StringTokenizer(br.readLine());
n = Integer.parseInt(st.nextToken());
k = Integer.parseInt(st.nextToken());
ans = Math.abs(n - k);
check = new boolean[100001];
if(0 <= n+1 && n+1 <= 100000) {
check[n+1] = true;
dfs(n + 1, 1, k);
}
if(0 <= n-1 && n-1 <= 100000) {
check[n-1] = true;
dfs(n - 1, 1, k);
}
if(0 <= n*2 && n*2 <= 100000) {
check[n*2] = true;
dfs(n * 2, 1, k);
}
System.out.println(ans);
}
}
쉽게 봤는데 생각보다 애를 좀 먹었다.
DFS로 접근하면 StackOverflow를 맞는다.
최단경로를 찾자마자 바로 반환하는 방식이 아니라 모든 경로를 다 찾은 후 그 중에서 최단경로를 구하는 방식이기 때문인 것 같다.
DFS 코드 첫째줄에 if(deptNow > ans) return 을 두어서 줄여보고자 했으나 역부족이었다.
풀이 2. (정답 코드)
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayDeque;
import java.util.Queue;
import java.util.StringTokenizer;
class Pair {
int now;
int time;
public Pair(int now, int time) {
this.now = now;
this.time = time;
}
}
public class Main {
static BufferedReader br = null;
static StringTokenizer st = null;
static int n, k, ans;
static boolean[] check = null;
public static void bfs(int start, int destination) {
Queue<Pair> que = new ArrayDeque<>();
que.add(new Pair(start, 0));
check[start] = true;
while(!que.isEmpty()) {
Pair p = que.poll();
int now = p.now;
int time = p.time;
if(now == destination) {
ans = time;
return;
}
if(0 <= now+1 && now+1 <= 100000 && !check[now+1]) {
que.add(new Pair(now+1, time+1));
check[now+1] = true;
}
if(0 <= now-1 && now-1 <= 100000 && !check[now-1]) {
que.add(new Pair(now-1, time+1));
check[now-1] = true;
}
if(0 <= now*2 && now*2 <= 100000 && !check[now*2]) {
que.add(new Pair(now*2, time+1));
check[now*2] = true;
}
}
}
public static void main(String[] args) throws IOException {
br = new BufferedReader(new InputStreamReader(System.in));
st = new StringTokenizer(br.readLine());
n = Integer.parseInt(st.nextToken());
k = Integer.parseInt(st.nextToken());
check = new boolean[100001];
bfs(n, k);
System.out.println(ans);
}
}
BFS를 사용해서 풀어야 각종 초과 에러들을 면할 수 있다.
목적지에 도착하자마자 바로 return하기 때문에 빠르게 해결할 수 있다.
'알고리즘 문제 > 백준 온라인 저지' 카테고리의 다른 글
[BOJ] 9019 - DSLR JAVA (0) | 2021.02.11 |
---|---|
[BOJ] 1963 - 소수 경로 JAVA (0) | 2021.02.11 |
[BOJ] 10971 - 외판원 순회 2 JAVA (0) | 2021.02.11 |
[BOJ] 10819 - 차이를 최대로 JAVA (0) | 2021.02.10 |
[BOJ] 1107 - 리모컨 JAVA (0) | 2021.02.10 |